﻿Imports System.Windows.Input
Imports Demo.ViewModel.Infrastructure

Public Class MyStartVm
    Inherits ViewModelBase

    Private _windowVm As MyTabWindowVm


    Public Sub New()
        VmTitle = "Startfenster"
    End Sub



#Region "Commands"

    Private _openChildWindowCommand As ICommand
    Public Property OpenChildWindowCommand() As ICommand
        Get
            If _openChildWindowCommand Is Nothing Then _openChildWindowCommand = New RelayCommand(AddressOf OpenChildWindowCommand_Execute, AddressOf OpenChildWindowCommand_CanExecute)
            Return _openChildWindowCommand
        End Get
        Set(ByVal value As ICommand)
            _openChildWindowCommand = value
            RaisePropertyChanged()
        End Set
    End Property

    Private Function OpenChildWindowCommand_CanExecute(obj As Object) As Boolean
        Return _windowVm Is Nothing OrElse Not _windowVm.IsOpen
    End Function

    Private Sub OpenChildWindowCommand_Execute(obj As Object)
        Dim winServ As IWindowService = ServiceContainer.GetService(Of IWindowService)
        _windowVm = New MyTabWindowVm With {.IsOpen = False, .ContentVm = New MySecondVm}
        winServ.ShowWindow("second", "Mein zweites Fenster", _windowVm)

    End Sub





    Private _increaseIndexCommand As ICommand
    Public Property IncreaseIndexCommand() As ICommand
        Get
            If _increaseIndexCommand Is Nothing Then _increaseIndexCommand = New RelayCommand(AddressOf IncreaseIndexCommand_Execute, AddressOf IncreaseIndexCommand_CanExecute)
            Return _increaseIndexCommand
        End Get
        Set(ByVal value As ICommand)
            _increaseIndexCommand = value
            RaisePropertyChanged()
        End Set
    End Property

    Private Function IncreaseIndexCommand_CanExecute(obj As Object) As Boolean
        Return _windowVm IsNot Nothing AndAlso _windowVm.IsOpen
    End Function
    Private Sub IncreaseIndexCommand_Execute(obj As Object)
        Dim seconVm As MySecondVm = DirectCast(_windowVm.ContentVm, MySecondVm)
        Dim currIndex As Integer = seconVm.SelectedIndex
        If currIndex < seconVm.TabCollection.Count - 1 Then
            seconVm.SelectedIndex += 1
        Else
            seconVm.SelectedIndex = 0
        End If


    End Sub



    Private _showDialogCommand As ICommand
    Public Property ShowDialogCommand() As ICommand
        Get
            If _showDialogCommand Is Nothing Then _showDialogCommand = New RelayCommand(AddressOf ShowDialogCommand_Execute)
            Return _showDialogCommand
        End Get
        Set(ByVal value As ICommand)
            _showDialogCommand = value
            RaisePropertyChanged()
        End Set
    End Property



    Private Sub ShowDialogCommand_Execute(obj As Object)
        Dim diagServ As IDialogWindowService = ServiceContainer.GetService(Of IDialogWindowService)
        Using modalVm As New MyModalVm With {.VmDescription = "Ich bin ein Dialogfenster.  Ich kann einen Beliebigen Inhalt haben!!"}
            diagServ.ShowModalDialog("newModal", "Ein Modaler Dialog!!", modalVm)
        End Using

    End Sub




    Private _messageCommand As ICommand
    Public Property Messagecommand() As ICommand
        Get
            If _messageCommand Is Nothing Then _messageCommand = New RelayCommand(AddressOf Messagecommand_Execute)
            Return _messageCommand
        End Get
        Set(ByVal value As ICommand)
            _messageCommand = value
            RaisePropertyChanged()
        End Set
    End Property

    Private Sub Messagecommand_Execute(obj As Object)

        Dim msgServ As IMessageboxService = ServiceContainer.GetService(Of IMessageboxService)
        Dim res As EnuMessageBoxResult = msgServ.Show("Das ist eine Messagebox, sehr Nice ;-)", "Meldung vom VM aus.", EnuMessageBoxVutton.YesNoCancel, EnuMessageBoxImage.Asterisk)

        msgServ.Show("Messageboxresult war " & res.ToString, "Ergebniss", EnuMessageBoxVutton.Ok, EnuMessageBoxImage.None)

    End Sub









#End Region



    Protected Overrides Sub Dispose(disposing As Boolean)
        MyBase.Dispose(disposing)
        _windowVm.Dispose()
    End Sub


End Class
